Package: microbiomeDataSets
Title: Experiment Hub based microbiome datasets
Version: 1.20.0
Authors@R: 
    c(
      person("Leo", "Lahti", role = c("cre", "aut"),
             comment = c(ORCID = "0000-0001-5537-637X"),
             email = "leo.lahti@iki.fi"),    
      person(given = "Felix G.M.", family = "Ernst", role = c("aut"),
             email = "felix.gm.ernst@outlook.com",      
             comment = c(ORCID = "0000-0001-5064-0928")),
      person(given = "Sudarshan", "Shetty", role = c("aut"),
             email = "sudarshanshetty9@gmail.com",
             comment = c(ORCID = "0000-0001-7280-9915")),
      person(given = "Chouaib", family = "Benchraka", role = c("ctb"),
             email = "chouaib.benchraka@utu.fi",
             comment = c(ORCID = "0000-0002-1167-7848")),
      person(given = "Yagmur", family = "Simsek", role = c("ctb"))	     
	     )
Description: 
    microbiomeDataSets is a collection of microbiome datasets loaded from 
    Bioconductor'S ExperimentHub infrastructure. The datasets serve as reference
    for workflows and vignettes published adjacent to the microbiome analysis 
    tools on Bioconductor. Additional datasets can be added overtime and 
    additions from authors are welcome.
License: CC0
Encoding: UTF-8
biocViews: ExperimentHub, ExperimentData, MicrobiomeData,
        SequencingData
Depends: R (>= 4.1), SummarizedExperiment, TreeSummarizedExperiment,
        MultiAssayExperiment
Imports: methods, utils, BiocGenerics, ExperimentHub, Biostrings, ape
Suggests: knitr, rmarkdown, BiocStyle, SingleCellExperiment, testthat
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/microbiomeDataSets
git_branch: RELEASE_3_23
git_last_commit: f7f9739
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-05-05
NeedsCompilation: no
Packaged: 2026-05-05 15:31:58 UTC; biocbuild
Author: Leo Lahti [cre, aut] (ORCID: <https://orcid.org/0000-0001-5537-637X>),
  Felix G.M. Ernst [aut] (ORCID: <https://orcid.org/0000-0001-5064-0928>),
  Sudarshan Shetty [aut] (ORCID: <https://orcid.org/0000-0001-7280-9915>),
  Chouaib Benchraka [ctb] (ORCID:
    <https://orcid.org/0000-0002-1167-7848>),
  Yagmur Simsek [ctb]
Maintainer: Leo Lahti <leo.lahti@iki.fi>

# `microbiomeDataSets`

<!-- badges: start -->

<!-- badges: end -->

This R package is a collection of microbiome datasets published initially elsewhere. The data is available as [`TreeSummarizedExperiment`](https://doi.org/doi:10.18129/B9.bioc.TreeSummarizedExperiment) or [`MultiAssayExperiment`](https://doi.org/doi:10.18129/B9.bioc.MultiAssayExperiment) and a list of available dataset can be retrieved via the `availableDataSets()` function.

The microbiomeDataSets package focuses mainly on non-human studies. The independent [curatedMetagenomicData](https://waldronlab.io/curatedMetagenomicData/index.html) package provides access to a large collection of standardized human microbiome studies in the same format. 

The aim is to provide datasets for teaching, example workflows or comparative efforts. If you have a dataset, which you like to see in this package, please let us know and/or provide a PR for the datasets.


# Contribution

Feel free to contribute. Have a look at how existing datasets are
organized and prepared data accordingly. It is also good to get in
touch at the earliest convenience to discuss any issues.

## Technical aspects

Let's use a gitflow approach. Development version should be
done against the `master` branch and then merged to `master` for the
next release.  (https://guides.github.com/introduction/flow/)

Resources on how data is added to Bioconductor's ExperimentHub backend and accessed are available from Bioconductor [ExperimentHub documentation](https://bioconductor.org/packages/release/bioc/vignettes/ExperimentHub/inst/doc/ExperimentHub.html) and in [Creating ExperimentHub Package](https://bioconductor.org/packages/release/bioc/vignettes/AnnotationHub/inst/doc/CreateAHubPackage.html).

Basic steps:

- Assemble a (Tree)SummarizedExperiment from the raw data 

- You can include the data creation script in inst/scripts/*-data-* (optional)

- Save the individual data container components as rds files 

- Prepare the metadata file, by creating a new
  metadata-<dataset-name>.R in inst/scripts and run the script to
  create inst/extdata/<bioc.version.number>/metadata-<dataset-name>.csv

- Make sure that the metadata files passes the check by running a script like:
  ExperimentHubData::makeExperimentHubMetadata("../microbiomeDataSets","3.13/metadata-hintikka-xo.csv")

- Maintainer will upload the data through their AWS login. The folder structure must match the one
  referenced in the metadata file; for example:
  microbiomeDataSets/<bioc.version.number>/lahti-ml/coldata.rds 

- Follow the [instructions](https://bioconductor.org/packages/release/bioc/vignettes/AnnotationHub/inst/doc/CreateAHubPackage.html) (See Section 7)

- Afterwards, the maintainer will push the new metadata to
  Bioconductor git repo and inform hubs@bioconductor that there is new
  metadata. They will let us know when the upload is done.

- In the meantime, prepare a loading function as found e.g. in
  microbiomeDataSets::LahtiMLData has to be created and push this to
  biocs git repo as well.

- Bump the version (note that the version scheme is different)

- For questions, have a look at the other datasets or check with us through [online
  channels](microbiome.github.io)
  
# Code of conduct

Please note that the microbiomeDataSets project is released with a 
[Contributor Code of Conduct](https://contributor-covenant.org/version/2/0/CODE_OF_CONDUCT.html).
By contributing to this project, you agree to abide by its terms.

#' Obtain the Silverman Artificial Gut data
#'
#' Obtain the microbiome data from Silverman et al. (2018).
#'
#' @details
#' The SilvermanAGutData dataset contains 16S rRNA gene based high-throughput
#' profiling of 4 in vitro artificial gut models. The sampling was done hourly
#' and daily to capture sub-daily dynamics of microbial community originating
#' from human feces. The data consists of 413 taxa from 639 samples. The data
#' set can be used to investigate longitudinal dynamics of microbial community
#' in a controlled environment.
#'
#' Column metadata includes the days of sampling, vessel identifier, sampling 
#' frequency pre-post challenge with Bacteroides ovatus.
#'
#' The wow metadata of the microbiome data contains taxonomic information on the
#' Kingdom, Phylum, Class, Order, Family and Genus and Species level.  
#' 
#' The row tree consists of a phylogenetic tree build using sequence information
#' of 413 taxa.  
#' 
#' As reference sequences the ASV are provided.
#' 
#' All data are downloaded from ExperimentHub and cached for local re-use.
#'
#' @return a \linkS4class{TreeSummarizedExperiment}
#'
#' @author Sudarshan A. Shetty and Felix G.M. Ernst
#'
#' @references
#' Silveman J.D et al. (2018): Dynamic linear models guide design and 
#' analysis of microbiota studies within artificial human guts. 
#' \emph{Microbiome} 6:202 \url{https://doi.org/10.1186/s40168-018-0584-3}
#'
#' @name SilvermanAGutData
#' @export
#'
#' @examples
#' tse <- SilvermanAGutData()
SilvermanAGutData <- function() {

    .Deprecated(
        msg=paste("SilvermanAGutData has been moved to the miaTime package.",
                    "The microbiomeDataSets::SilvermanAGutData",
                    "will be deprecated soon."))

    dataset <- "3.13/silverman-ag"
    tse <- .create_tse(dataset,
                    assays = c("counts"),
                    has.rowdata = TRUE,
                    has.coldata = TRUE,
                    has.rowtree = TRUE,
                    has.refseq = TRUE)
    tse
}

#' @rdname SilvermanAGutData
#' @export
artificialgut <- SilvermanAGutData

library(SummarizedExperiment)
library(TreeSummarizedExperiment)
library(dplyr)
library(phyloseq)
library(ape)
library(forcats)

#Sample phenotype data
orig.data <- "grieneisen-ts-original/"

#Phylogenetic tree
pseq <- readRDS(paste0(orig.data, "asv_10prev_phyloseq_for_lahti.RDS"))
tree <- phy_tree(pseq)
tree <- makeNodeLabel(tree, method="number", prefix='n')
leaves <- tree$tip.label

samples <- read.csv(paste0(orig.data, "git_metadata_and_community_phenotypes.csv"))
rownames(samples) <- samples$sample
samples$X <- NULL
samples[,c("baboon_id", "sex", "social_group", "season" ,"plate")] <- lapply(samples[,c("baboon_id", "sex", "social_group", "season" ,"plate")],as.factor)
samples$collection_date <- as.Date(samples$collection_date, format="%Y-%m-%d")

#Abundance table
counts <- readRDS(paste0(orig.data, "git_ASV_table.RDS"))
rownames(counts) <- counts$asv_id
# Pick the subset of taxa for which we have tree
counts <- counts[leaves,]

#sequence information
ASV_Sequence <- counts$asv_sequence
ref_seq <- data.frame(ASV_Sequence)
rownames(ref_seq) <- rownames(counts)

#Taxonomic mapping table
tax <- select(counts, domain, phylum, class, order, family, genus, asv_id)
rownames(tax) <- counts$asv_id

# In order to make sure that the samples match between the abundance and phenodata tables
counts_trimmed <- counts[, rownames(samples)]

#Taxonomy Table
tax <- tax  %>% dplyr::rename(c(
  Domain = "domain",
  Phylum = "phylum",
  Class = "class",
  Order = "order",
  Family = "family",
  Genus = "genus",
  ASV = "asv_id"
  ))
tax$ASV<- as.factor(tax$ASV)

# sequence information
refSeq <- DNAStringSet(ASV_Sequence, start=NA, end=NA, width=NA, use.names=TRUE)

tse <- TreeSummarizedExperiment(assays = list(counts = counts_trimmed[leaves, ]),
                                colData = samples,
                                rowData = tax[leaves, ],
				rowTree = tree,
                                referenceSeq = refSeq)

#Subsetting- not needed now; already subsetted above
# subsetByLeaf(tse = tse, rowLeaf = tree$tip.label)

rowdata <- rowData(tse)
coldata <- colData(tse)
counts <- assay(tse, "counts")
rowtree <- rowTree(tse)
refseq <- referenceSeq(tse)

counts <- as.matrix(counts)

data <- "microbiomeDataSets/3.14/"

saveRDS(counts, file = paste0(data,"counts.rds"))
saveRDS(coldata, file = paste0(data,"coldata.rds"))
saveRDS(rowdata , file = paste0(data, "rowdata.rds"))

treefile <- paste0(data, "rowtree.tre")
write.tree(rowtree, file=treefile)
gz_tree<- gzfile(treefile, "w")
writeLines(readLines(treefile), con=gz_tree)
close(gz_tree)
unlink(treefile)

Biostrings::writeXStringSet(refseq, "refseq.fasta.gz", compress = TRUE)

#' Microbiome data sets 
#' 
#' \code{microbiomeDataSets} is a collation of data from microbiome and 
#' associated studies, which are publicaly available. 
#' 
#' The data is made available through the ExperimentHub resources of the
#' Bioconductor project. It is loaded as \code{TreeSummarizedExperiment} 
#' object or a \code{MultiAssayExperiment} objects.
#' 
#' @name microbiomeDataSets-package
NULL

#' @importFrom BiocGenerics updateObject
#' @importFrom methods as
NULL

# Base data for all data sets --------------------------------------------------
library(S4Vectors)

BiocVersion <- "3.13"
path <- paste0("microbiomeDataSets/",BiocVersion,"/")

df_Base <- DataFrame(
    BiocVersion = BiocVersion,
    SourceVersion = NA,
    Coordinate_1_based = TRUE,
    Species = "Homo sapiens",
    TaxonomyId = "9606",
    SourceVersion = Sys.time(),
    Genome = NA,
    SourceUrl = "https://doi.org/10.1038/ncomms5344",
    DataProvider = NA,
    Maintainer = "Leo Lahti <leo.lahti@iki.fi>"
)

#

df <- rbind(
    cbind(df_Base,
          DataFrame(Title = "Lahti Western Adult microbiome counts",
                    Description = paste0("Count matrix for the Lahti Western Adult microbiome dataset"),
                    SourceType = "CSV",
                    RDataClass = "matrix",
                    DispatchClass = "Rds",
                    RDataPath = paste0(path,"lahti-wa/counts.rds"),
                    Tags = NA)),
    cbind(df_Base,
          DataFrame(Title = "Lahti Western Adult microbiome row data",
                    Description = paste0("Row data for the Lahti Western Adult microbiome dataset"),
                    SourceType = "CSV",
                    RDataClass = "DFrame",
                    DispatchClass = "Rds",
                    RDataPath = paste0(path,"lahti-wa/rowdata.rds"),
                    Tags = NA)),
    cbind(df_Base,
          DataFrame(Title = "Lahti Western Adult sample data",
                    Description = paste0("Sample data for the Lahti Western Adult dataset"),
                    SourceType = "CSV",
                    RDataClass = "DFrame",
                    DispatchClass = "Rds",
                    RDataPath = paste0(path,"lahti-wa/coldata.rds"),
                    Tags = NA))
)

df$Tags <- paste(df$Tags[!is.na(df$Tags)],"Microbiome",collapse = ":",sep="")

write.csv(df, file = paste0("../extdata/",BiocVersion,"/metadata-lahti-wa.csv"),
          row.names = FALSE)

#' Load available microbiome data sets
#' 
#' To list the available datasets in \code{microbiomeDataSets},
#' run \code{availableDataSets}.
#' 
#' For information visit the individual man pages.
#' 
#' @return 
#' A \code{data.frame} containing the following columns:
#' \itemize{
#'   \item{Dataset:} {the name of the function to load a dataset}
#' }
#' 
#' @export
#' 
#' @importFrom utils read.csv
#' 
#' @examples
#' availableDataSets()
availableDataSets <- function(){
    file <- system.file("extdata","datasets.csv",package = "microbiomeDataSets")
    read.csv(file, stringsAsFactors = FALSE)
}

####################################################################
# ExperimentHub data loading

.get_res_by_path <- function(hub, path, failOnError = TRUE){
    res <- hub[hub$rdatapath==path]

    if(length(res) > 1L){
        stop("Multiple resources found.")
    }
    if(length(res) == 0L && failOnError){
        stop("No resources found for ",path,".")
    } else if(length(res) == 0L) {
        return(NULL)
    }
    res[[1L]]
}

###################################################################
# object creation 

#' @importFrom ExperimentHub ExperimentHub
#' @importFrom MultiAssayExperiment MultiAssayExperiment
.create_mae <- function(dataset,
                        types = list(),
                        hub = ExperimentHub(),
                        coldata = TRUE,
                        samplemap = TRUE,
                        has.rowdata = list(),
                        has.coldata = list()){

    el <- .get_experiment_list(dataset, hub, types, has.rowdata, has.coldata)
    args <- .get_col_row_map_data(dataset, hub,
                                has.rowdata = FALSE,
                                has.coldata = coldata,
                                has.samplemap = samplemap)
    do.call(MultiAssayExperiment, c(list(el), args))
}

#' @importFrom MultiAssayExperiment ExperimentList
.get_experiment_list <- function(dataset, hub,
                                types = list(),
                                has.rowdata = list(),
                                has.coldata = list()){
    experiments <- mapply(
        function(prefix, se, hr, hc){
            stopifnot(length(se) == 1L)
            FUN <- switch(names(se),
                        TSE = .create_tse,
                        SE = .create_se)
            do.call(FUN, list(dataset = dataset,
                            hub = hub,
                            assays = se[[1L]],
                            has.rowdata = hr,
                            has.coldata = hc,
                            prefix = prefix))
        },
        names(types),
        types,
        has.rowdata,
        has.coldata)
    names(experiments) <- names(types)
    do.call(ExperimentList, experiments)
}

#' @importFrom ExperimentHub ExperimentHub
#' @importFrom TreeSummarizedExperiment TreeSummarizedExperiment
.create_tse <- function(dataset,
                        hub = ExperimentHub(),
                        assays = "counts",
                        has.rowdata = TRUE,
                        has.coldata = TRUE,
                        has.rowtree = FALSE,
                        has.coltree = FALSE,
                        has.refseq = FALSE,
                        prefix = NULL) {
    assays <- .get_assays(dataset, hub, assays, prefix)
    args <- .get_col_row_map_data(dataset, hub, prefix,
                                has.rowdata = has.rowdata,
                                has.coldata = has.coldata)
    tse <- do.call(TreeSummarizedExperiment, c(list(assays=assays), args))
    tse <- .add_refseq(dataset, hub, prefix = prefix,
                    tse, has.refseq)
    tse <- .add_trees(dataset, hub, prefix = prefix,
                    tse, has.rowtree, has.coltree)
    tse
}
#' @importFrom ExperimentHub ExperimentHub
#' @importFrom SummarizedExperiment SummarizedExperiment
.create_se <- function(dataset,
                    hub = ExperimentHub(),
                    assays = "counts",
                    has.rowdata = TRUE,
                    has.coldata = TRUE,
                    prefix = NULL) {
    assays <- .get_assays(dataset, hub, assays, prefix)
    args <- .get_col_row_map_data(dataset, hub, prefix,
                                has.rowdata = has.rowdata,
                                has.coldata = has.coldata)
    do.call(SummarizedExperiment, c(list(assays=assays), args))
}

#########################################################################
# path utils

.get_base_path <- function(dataset){
    file.path("microbiomeDataSets", dataset)
}

.norm_prefix <- function(prefix){
    if (is.null(prefix)) {
        prefix <- ""
    } else {
        prefix <- paste0(prefix, "_")
    }
    prefix
}

################################################################################
# assay data

.get_assays <- function(dataset, hub, assays, prefix = NULL){
    base <- .get_base_path(dataset)
    prefix <- .norm_prefix(prefix)
    assay_list <- list()
    for (a in assays) {
        path <- file.path(base, sprintf("%s%s.rds", prefix, a))
        assay_list[[a]] <- .get_res_by_path(hub, path)
    }
    names(assay_list) <- assays
    assay_list
}

################################################################################
# row, column and sample map data

.get_col_row_map_data <- function(dataset, hub,
                                prefix = NULL,
                                has.rowdata = TRUE,
                                has.coldata = TRUE,
                                has.samplemap = FALSE){
    base <- .get_base_path(dataset)
    prefix <- .norm_prefix(prefix)
    args <- list()
    if (has.coldata) {
        path <- file.path(base, sprintf("%scoldata.rds", prefix))
        args$colData <- .get_res_by_path(hub, path)
    }
    if (has.rowdata) {
        path <- file.path(base, sprintf("%srowdata.rds", prefix))
        args$rowData <- .get_res_by_path(hub, path)
    }
    if (has.samplemap) {
        path <- file.path(base, sprintf("%ssamplemap.rds", prefix))
        args$sampleMap <- .get_res_by_path(hub, path)
    }
    args
}

################################################################################
# tree data loading

#' @importFrom ape read.tree
#' @importFrom TreeSummarizedExperiment LinkDataFrame
#' @importClassesFrom TreeSummarizedExperiment LinkDataFrame
.get_tree_data <- function(dataset, hub,
                        prefix = NULL,
                        type = c("row","column")){
    base <- .get_base_path(dataset)
    prefix <- .norm_prefix(prefix)
    name <- switch(type,
                row = "rowtree",
                column = "coltree")
    tree <- file.path(base, sprintf("%s%s.tre.gz", prefix, name))
    links <- file.path(base, sprintf("%s%s_links.rds", prefix, name))
    tree <- read.tree(.get_res_by_path(hub, tree))
    links <- .get_res_by_path(hub, links, failOnError = FALSE)
    if(!is.null(links)){
        links <- as(links,"LinkDataFrame")
    }
    list(tree = tree, links = links)
}

#' @importFrom TreeSummarizedExperiment changeTree
.add_tree <- function(tse, tree_data, type = c("row","column")){
    if(length(tree_data$links) == 0L){
        if(type == "row"){
            tse <- changeTree(tse, rowTree = tree_data$tree)
        } else {
            tse <- changeTree(tse, colTree = tree_data$tree)
        }
    } else {
        if(type == "row"){
            tse@rowLinks <- tree_data$links
            tse@rowTree$phylo <- tree_data$tree
        } else {
            tse@colinks <- tree_data$links
            tse@colTree$phylo <- tree_data$tree
        }
    }
    updateObject(tse)
}

.add_trees <- function(dataset, hub,
                    prefix = NULL,
                    tse,
                    has.rowtree = FALSE,
                    has.coltree = FALSE){
    
    if(has.rowtree){
        tree_data <- .get_tree_data(dataset, hub, prefix = prefix, type = "row")
        tse <- .add_tree(tse, tree_data = tree_data, type = "row")
    }
    if(has.coltree){
        tree_data <- .get_tree_data(dataset, hub, prefix = prefix,
                                    type = "column") 
        tse <- .add_tree(tse, tree_data = tree_data, type = "column")
    }
    tse
}

################################################################################
# reference sequence

#' @importFrom Biostrings readDNAStringSet
#' @importFrom TreeSummarizedExperiment referenceSeq<- 
.add_refseq <- function(dataset, hub, prefix = NULL,
                        tse,
                        has.refseq = FALSE){
    if(has.refseq){
        base <- .get_base_path(dataset)
        prefix <- .norm_prefix(prefix)
        refSeq <- file.path(base, sprintf("%srefseq.fasta.gz", prefix))
        refSeq <- .get_res_by_path(hub,refSeq)
        refSeq <- readDNAStringSet(refSeq)
        names <- names(refSeq)
        if(!is.null(names) && all(grepl("_ \\|\\|_",names))){
            groups <- regmatches(names,regexec("(.+)_\\|\\|_.*",names))
            groups <- vapply(groups,"[[",character(1),2L)
            names <- regmatches(names,regexec(".*_\\|\\|_(.+)",names))
            names <- vapply(names,"[[",character(1),2L)
            names(refSeq) <- names
            refSeq <- split(refSeq, factor(groups,unique(groups)))
            names(refSeq) <- unique(groups)
        }
        referenceSeq(tse) <- refSeq
    }
    tse
}

#' Obtain the Lahti Microbiome and Lipid data
#'
#' Obtain the microbiome and lipid data from Lahti et al. (2013).
#'
#' @details
#' The LahtiML dataset contains high-throughput profiling data from 389 human
#' blood serum lipids and 130 intestinal genus-level bacteria from 44 samples
#' (22 subjects from 2 time points; before and after probiotic/placebo
#' intervention). The data set can be used to investigate associations between
#' intestinal bacteria and host lipid metabolism
#'
#' This data set is based on the Human Intestinal Tract (HIT)Chip
#' phylogenetic 16S microarray (Rajilic-Stojanovic _et al._ 2009.
#' This profiling technology differs from the more widely used 16S rRNA
#' amplicon sequencing.
#'
#' Column metadata includes the time points, sex, subject identifier, sample
#' identifier and treatment group.
#'
#' Row metadata of the microbiome data contains taxonomic information on the
#' Phylum, Family and Genus level.
#'
#' All data are downloaded from ExperimentHub and cached for local re-use.
#'
#' @return for  \code{LahtiMLData} a \linkS4class{MultiAssayExperiment} object
#'   with \linkS4class{TreeSummarizedExperiment} and a
#'   \linkS4class{SummarizedExperiment},
#'   for  \code{LahtiMData} a \linkS4class{TreeSummarizedExperiment}
#'
#' @author Felix G.M. Ernst and Leo Lahti
#'
#' @references
#' Lahti L et al. (2013): Associations between the human intestinal microbiota,
#' Lactobacillus rhamnosus GG and serum lipids indicated by integrated analysis
#' of high-throughput profiling data.
#' \emph{PeerJ} 1:e32 \url{https://doi.org/10.7717/peerj.32}
#'
#' Rajilic-Stojanovic M, Heilig HG, Molenaar D, Kajander K, Surakka A, Smidt H,
#' de Vos WM (2009). Development and application of the human intestinal tract 
#' chip, a phylogenetic microarray: analysis of universally conserved phylotypes
#' in the abundant microbiota of young and elderly adults.
#' \emph{Environ Microbiol.} 11(7):1736-51
#' \url{https://doi.org/10.1111/j.1462-2920.2009.01900.x}
#'
#' @name LahtiMLData
#' @export
#'
#' @examples
#' mae <- LahtiMLData()
#' tse <- LahtiMData()
LahtiMLData <- function() {
    mae <- .create_mae("3.13/lahti-ml",
                    types = list(microbiome = list("TSE" = c("counts")),
                                    lipids = list("SE" = c("counts"))),
                    coldata = TRUE,
                    samplemap = FALSE,
                    has.rowdata = list(microbiome = TRUE,
                                        lipids = FALSE),
                    has.coldata = list(microbiome = FALSE,
                                        lipids = FALSE))
    mae
}
#' @rdname LahtiMLData
#' @importFrom SummarizedExperiment colData<-
#' @export
LahtiMData <- function() {
    dataset <- "3.13/lahti-ml"
    hub <- ExperimentHub()
    tse <- .create_tse(dataset,
                    hub = hub,
                    assays = c("counts"),
                    has.rowdata = TRUE,
                    has.coldata = FALSE,
                    prefix = "microbiome")
    args <- .get_col_row_map_data(dataset,
                                hub = hub,
                                has.rowdata = FALSE,
                                has.coldata = TRUE)
    colData(tse) <- args$colData
    tse
}

#' @rdname LahtiMLData
#' @export
peerj32 <- LahtiMLData

context("Loading of GrieneisenTSData data")
test_that("Loading of GrieneisenTSData data", {
  tse <- GrieneisenTSData()
  expect_s4_class(tse, "TreeSummarizedExperiment")
})

context("Loading of LahtiMData data")
test_that("Loading of LahtiMData data", {
  mae <- LahtiMLData()
  expect_s4_class(mae, "MultiAssayExperiment")
  tse <- LahtiMData()
  expect_s4_class(tse, "TreeSummarizedExperiment")
})

context("Loading of OKeefeDSData data")
test_that("Loading of OKeefeDSData data", {
  tse <- OKeefeDSData()
  expect_s4_class(tse, "TreeSummarizedExperiment")
})

context("Loading of SilvermanAGutData data")
test_that("Loading of SilvermanAGutData data", {
  tse <- SilvermanAGutData()
  expect_s4_class(tse, "TreeSummarizedExperiment")
})

context("Loading of SongQAData data")
test_that("Loading of SongQAData data", {
  tse <- SongQAData()
  expect_s4_class(tse, "TreeSummarizedExperiment")
})

context("Loading of GrieneisenTS data")
test_that("Loading of a GrieneisenTS data", {
  tse <- GrieneisenTSData()
  expect_s4_class(tse, "TreeSummarizedExperiment")
})

context("Loading of SprockettTHData data")
test_that("Loading of SprockettTHData data", {
  tse <- SprockettTHData()
  expect_s4_class(tse, "TreeSummarizedExperiment")
})

# Base data for all data sets --------------------------------------------------
library(S4Vectors)

BiocVersion <- "3.14"
path <- paste0("microbiomeDataSets/",BiocVersion,"/")

df_Base <- DataFrame(
    BiocVersion = BiocVersion,
    SourceVersion = NA,
    Coordinate_1_based = TRUE,
    Species = "Rattus norvegicus",
    TaxonomyId = "10116",
    SourceVersion = Sys.time(),
    Genome = NA,
    SourceUrl = "https://ndownloader.figshare.com/files/",
    DataProvider = "University of Jyvaskyla",
    Maintainer = "Leo Lahti <leo.lahti@iki.fi>"
)


df <- rbind(
    cbind(df_Base,
          DataFrame(Title = "Hintikka XO sample data",
                    Description = paste0("Sample data for the HintikkaXO dataset"),
                    SourceType = "XLS/XLSX",
                    RDataClass = "DFrame",
                    DispatchClass = "Rds",
                    RDataPath = paste0(path,"hintikka-xo/coldata.rds"),
                    Tags = NA)),
		    
    cbind(df_Base,
          DataFrame(Title = "Hintikka XO microbiota row data",
                    Description = paste0("Row data for the HintikkaXO microbiota dataset"),
                    SourceType = "XLS/XLSX",
                    RDataClass = "DFrame",
                    DispatchClass = "Rds",
                    RDataPath = paste0(path,"hintikka-xo/microbiota_rowdata.rds"),
                    Tags = NA)),

    cbind(df_Base,
          DataFrame(Title = "Hintikka XO microbiota counts",
                    Description = paste0("Count matrix for the HintikkaXO microbiota dataset"),
                    SourceType = "XLS/XLSX",
                    RDataClass = "matrix",
                    DispatchClass = "Rds",
                    RDataPath = paste0(path,"hintikka-xo/microbiota_counts.rds"),
                    Tags = NA)),		    

    cbind(df_Base,
          DataFrame(Title = "Hintikka XO metabolites",
                    Description = paste0("Count matrix for the HintikkaXO metabolites"),
                    SourceType = "XLS/XLSX",
                    RDataClass = "matrix",
                    DispatchClass = "Rds",
                    RDataPath = paste0(path,"hintikka-xo/metabolites_nmr.rds"),
                    Tags = NA)),

    cbind(df_Base,
          DataFrame(Title = "Hintikka XO biomarkers",
                    Description = paste0("Data matrix for the HintikkaXO biomarkers"),
                    SourceType = "XLS/XLSX",
                    RDataClass = "matrix",
                    DispatchClass = "Rds",
                    RDataPath = paste0(path,"hintikka-xo/biomarkers_signals.rds"),
                    Tags = NA))
)

df$Tags <- paste(df$Tags[!is.na(df$Tags)],"Microbiome",collapse = ":",sep="")

write.csv(df, file = paste0("../extdata/",BiocVersion,"/metadata-hintikka-xo.csv"),
          row.names = FALSE)

#' Retrieve GrieneisenTS data
#'
#' Obtain longitudinal gut microbiome data in wild baboons from
#' Grieneisen et al. (2021).
#'
#' @details
#' The GrieneisenTS dataset contains 16,234 16S rRNA gene
#' sequencing-based microbiome profiles from 585 baboon samples
#' collected over 14 years to determine the heritability of the
#' gut microbiome on various environmental factors such as
#' diet, age, season. Each baboon had an average of 28 samples
#' collected over 4.5 years. The data set can be used to
#' investigate significance of longitudinal sampling at large
#' sample sizes.
#'
#' This data set contains the 613 most prevalent taxa with a 
#' phylogenetic tree.
#'
#' Column metadata includes the following fields:
#'\itemize{
#'  \item{sample: } {Sample ID (character)}
#'  \item{baboon_id: } {Baboon ID (factor)}
#'  \item{collection_date: } {Sample collection date (date ; YYYY-MM-DD)}
#'  \item{sex: } {Sex (factor; F/M)}
#'  \item{age: } {Age (numeric)}
#'  \item{social_group: } {Social group ID (factor)}
#'  \item{group_size: } {Social group size (integer)}
#'  \item{rain_month_mm: } {Rain per month(mm) (numeric)}
#'  \item{season: } {Season (factor; dry/wet)}
#'  \item{hydro_year: } {Hydro year (integer)}
#'  \item{month: } {Month (integer)}
#'  \item{readcount: } {Read count (numeric)}
#'  \item{plate: } {Plate (factor)}
#'  \item{post_pcr_dna_ng: } {Post PCR DNA(ng) (numeric)}
#'  \item{diet_PC1: } {Diet Principal coordinate 1 (numeric)}
#'  \item{diet_PC2: } {Diet Principal coordinate 2 (numeric)}
#'  \item{diet_PC3: } {Diet Principal coordinate 3 (numeric)}
#'  \item{diet_PC4: } {Diet Principal coordinate 4 (numeric)}
#'  \item{diet_PC5: } {Diet Principal coordinate 5 (numeric)}
#'  \item{diet_PC6: } {Diet Principal coordinate 6 (numeric)}
#'  \item{diet_PC7: } {Diet Principal coordinate 7 (numeric)}
#'  \item{diet_PC8: } {Diet Principal coordinate 8 (numeric)}
#'  \item{diet_PC9: } {Diet Principal coordinate 9 (numeric)}
#'  \item{diet_PC10: } {Diet Principal coordinate 10 (numeric)}
#'  \item{diet_PC11: } {Diet Principal coordinate 11 (numeric)}
#'  \item{diet_PC12: } {Diet Principal coordinate 12 (numeric)}
#'  \item{diet_PC13: } {Diet Principal coordinate 13 (numeric)}
#'  \item{diet_shannon_h: } {Dietary Shannon's H index (numeric)}
#'  \item{asv_richness: } {Amplicon sequence variant (ASV) richness (integer)}
#'  \item{asv_shannon_h: } {ASV Shannon's H index (numeric)}
#'  \item{pc1_bc: } {Principal coordinate 1 Bray-Curtis dissimilarity (numeric)}
#'  \item{pc2_bc: } {Principal coordinate 2 Bray-Curtis dissimilarity (numeric)}
#'  \item{pc3_bc: } {Principal coordinate 3 Bray-Curtis dissimilarity (numeric)}
#'  \item{pc4_bc: } {Principal coordinate 4 Bray-Curtis dissimilarity (numeric)}
#'  \item{pc5_bc: } {Principal coordinate 5 Bray-Curtis dissimilarity (numeric)}
#'}
#'
#' Row metadata of the microbiome data contains taxonomic information on the
#' Domain, Phylum, Class, Order, Family, Genus, and ASV levels.
#'
#' The row tree consists of a phylogenetic tree build using sequence
#' information of 613 taxa.
#'
#' As reference sequences the ASV are provided.
#'
#' @return A \linkS4class{TreeSummarizedExperiment} object.
#'
#' @author Yagmur Simsek and Leo Lahti
#'
#' @references
#' Grieneisen et al. (2021):
#' Gut microbiome heritability is nearly universal but
#' environmentally contingent
#' \emph{Science}
#' 373:6551 \url{https://science.sciencemag.org/content/373/6551/181.full}
#'
#' @name GrieneisenTSData
#' @aliases baboongut
#' @export
#'
#' @examples
#' tse <- GrieneisenTSData()
#'
GrieneisenTSData <- function() {
    dataset <- "3.14/grieneisen-ts"
    tse <- .create_tse(dataset,
                    assays = "counts",
                    has.rowdata = TRUE,
                    has.coldata = TRUE,
                    has.rowtree = TRUE,
                    has.refseq = TRUE,
                    prefix = NULL)
    tse
}

#' @rdname GrieneisenTSData
#' @export
baboongut <- GrieneisenTSData

# Base data for all data sets --------------------------------------------------
library(S4Vectors)

BiocVersion <- "3.13"
path <- paste0("microbiomeDataSets/",BiocVersion,"/")

df_Base <- DataFrame(
  BiocVersion = BiocVersion,
  SourceVersion = NA,
  Coordinate_1_based = TRUE,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  SourceVersion = Sys.time(),
  Genome = NA,
  SourceUrl = "https://www.nature.com/articles/s41467-020-17541-6#Abs1",
  DataProvider = NA,
  Maintainer = "Sudarshan Shetty <sudarshanshetty9@gmail.com>"
)

#

df <- rbind(
  cbind(df_Base,
        DataFrame(Title = "Sprockett Tsimane Horticulturalists microbiome counts",
                  Description = paste0("Count matrix for the Sprockett microbiome dataset"),
                  SourceType = "CSV",
                  RDataClass = "matrix",
                  DispatchClass = "Rds",
                  RDataPath = paste0(path,"sprockett-th/counts.rds"),
                  Tags = NA)),
  cbind(df_Base,
        DataFrame(Title = "Sprockett Tsimane Horticulturalists row data",
                  Description = paste0("Row data for the Sprockett microbiome dataset"),
                  SourceType = "CSV",
                  RDataClass = "DFrame",
                  DispatchClass = "Rds",
                  RDataPath = paste0(path,"sprockett-th/rowdata.rds"),
                  Tags = NA)),
  cbind(df_Base,
        DataFrame(Title = "Sprockett Tsimane Horticulturalists sample data",
                  Description = paste0("Sample data for the Sprockett dataset"),
                  SourceType = "CSV",
                  RDataClass = "DFrame",
                  DispatchClass = "Rds",
                  RDataPath = paste0(path,"sprockett-th/coldata.rds"),
                  Tags = NA)),
  cbind(df_Base,
        DataFrame(Title = "Sprockett Tsimane Horticulturalists tree data",
                  Description = paste0("Feature tree data for the Sprockett dataset"),
                  SourceType = "TXT",
                  RDataClass = "character",
                  DispatchClass = "FilePath",
                  RDataPath = paste0(path,"sprockett-th/rowtree.tre.gz"),
                  Tags = NA)),
  cbind(df_Base,
        DataFrame(Title = "Sprockett Tsimane Horticulturalists reference sequence data",
                  Description = paste0("Reference sequences data for the Sprockett dataset"),
                  SourceType = "TXT",
                  RDataClass = "character",
                  DispatchClass = "FilePath",
                  RDataPath = paste0(path,"sprockett-th/refseq.fasta.gz"),
                  Tags = NA))
)

df$Tags <- paste(df$Tags[!is.na(df$Tags)],"Microbiome",collapse = ":",sep="")

write.csv(df, file = paste0("../extdata/",BiocVersion,"/metadata-sprockett-th.csv"),
          row.names = FALSE)

#' Obtain the Sprockett Tsimane Horticulturalists data
#'
#' Obtain the microbiome data from Sprockett et al. (2020).
#'
#' @details
#' The SprockettTHData dataset contains 16S rRNA gene based high-throughput
#' profiling of 1966 Feces, 120 Saliva samples from 319 participants from 
#' Bolivia, Finland and Bangladesh. These include samples from adults, 
#' children, and infants. Several participants have longitudinal samples. 
#' The data consists of 2319 taxa from 2086 samples. The data
#' set can be used to investigate assembly, structure, and dynamics as well 
#' as associations between several host related parameters with microbiota.
#'
#' Column metadata includes the sex, age, feeding status, delivery mode, 
#' country, and other information.
#'
#' The row metadata of the microbiome data contains taxonomic information 
#' on the Kingdom, Phylum, Class, Order, Family and Genus, Species and 
#' lowest taxonomic rank.  
#' 
#' The row tree consists of a phylogenetic tree build using sequence 
#' information of 2319 taxa.
#' 
#' 
#' As reference sequences the ASV are provided.
#' 
#' All data are downloaded from ExperimentHub and cached for local re-use.
#'
#' @return a \linkS4class{TreeSummarizedExperiment}
#'
#' @author Sudarshan A. Shetty and Felix G.M. Ernst
#'
#' @references
#' Sprockett, D.D., Martin, M., Costello, E.K. et al. (2020)
#' Microbiota assembly, structure, and dynamics among Tsimane
#' horticulturalists of the Bolivian Amazon. 
#' \emph{Nat Commun} 11, 3772 \url{https://doi.org/10.1038/s41467-020-17541-6}
#'
#' Subramanian, S., Huq, S., Yatsunenko, T., et al. (2014) Persistent gut
#' microbiota immaturity in malnourished Bangladeshi children. 
#' \emph{Nature} 510, 417-421 \url{https://doi.org/10.1038/nature13421}
#' 
#' Vatanen, T., Kostic A.D., d'Hennezel E., et al. (2016) Variation in
#' microbiome LPS immunogenicity contributes to autoimmunity in humans. 
#' \emph{Cell} 165, 842-853 \url{https://doi.org/10.1016/j.cell.2016.04.007}
#' 
#' @name SprockettTHData
#' @export
#'
#' @examples
#' tse <- SprockettTHData()
SprockettTHData <- function() {
    dataset <- "3.13/sprockett-th"
    tse <- .create_tse(dataset,
                    assays = c("counts"),
                    has.rowdata = TRUE,
                    has.coldata = TRUE,
                    has.rowtree = TRUE,
                    has.refseq = TRUE)
    tse
}

library(microbiomeDataSets)
library(readxl)
library(dplyr)
library(tidyr)
library(stringr)

temp_data <- "../extras/temp_data/hintikka-xo-original/"

# Read metabolite data
rename <- dplyr::rename
nmr <- read_excel(paste0(temp_data, "NMR_Quantification.xlsx")) %>%
         rename(Rat = "RAT ID") %>%
         rename(Group = "Group ID") %>%
	 select(-Group)

# Sample metadata
meta <- read_excel(paste0(temp_data, "Otut_abundanssit_metadata_ok.xlsx"),
           sheet = "Metadata") %>%
         rename(Rat = "Rotta ID") %>%
         rename(Group = "Ryhmä nro") %>%
         rename(Batch = "Sekvensointi ID") %>%
	 select(-Batch) %>% # Same as "Rat"
	 select(-Group) %>% # Not needed
         rename(Site = "Suolen osa") %>%
	 rename(Sample = Rat) %>% # These are sample IDs
         mutate(Rat = str_remove(Sample, "^[P|C]")) %>%	 # These are subject IDs 
	 mutate(Fat = factor(str_trim(str_remove(str_remove(Diet, "\\+ XOS"), "-fat")),
             levels = c("Low", "High"))) %>%
   mutate(XOS = as.numeric(str_replace(replace_na(str_match(Diet, "XOS"), 0), "XOS", "1")))



# Read microbiota data
ngs <- read_excel(paste0(temp_data, "Otut_abundanssit_metadata_ok.xlsx"),
  sheet = "OTU table siisti")

## Separate taxonomy table and abundances
tax <- ngs[, 1:7] %>%
         rename(OTU = "OTU ID") %>%
         rename(Phylum = "D1") %>%
         rename(Class = "D2") %>%
         rename(Order = "D3") %>%
         rename(Family = "D4") %>%
         rename(Genus = "D5") %>%
         rename(Species = "D6") 	 
tax <- tax[, c(2:7, 1)]
tax <- DataFrame(tax)
rownames(tax) <- tax$OTU

# Pick microbiota abundances
otu <- ngs[, 8:ncol(ngs)]

# Only Cecum data was used in the paper;
# separate metadata and blood+other measurements
inds <- which(meta$Site == "Cecum") # Check matching.txt
vars <- c("Sample", "Rat", "Site", "Diet", "Fat", "XOS")
meta_cecum <- as.data.frame(meta[inds, vars])
meta_cecum <- DataFrame(meta_cecum)
rownames(meta_cecum) <- meta_cecum$Sample
meta_cecum$Rat  <- as.factor(meta_cecum$Rat)
meta_cecum$Diet <- as.factor(meta_cecum$Diet)
meta_cecum$Fat  <- as.factor(meta_cecum$Fat)
#meta_cecum$XOS <- as.factor(meta_cecum$XOS)

# Manually checked that the sample order corresponds;
# let us rename the samples so they have same names in the different tables
otu_cecum <- as.matrix(otu[, inds])
rownames(otu_cecum) <- rownames(tax)
colnames(otu_cecum) <- meta_cecum$Sample

skip <- TRUE
if (!skip) {
# Add tree data
seqdata <- read_excel(paste0(temp_data, "OTU97_lopetus_cecum_proxcolon_Leolle.xlsx"))
# OTU names match ok
all(rownames(otu) == seqdata$Name)
#seqs <- dada2::getSequences(x[["Start of sequence"]])
seqs <- seqdata[["Start of sequence"]]
names(seqs) <- seqs
sum(duplicated(names(seqs)))

alignment <- DECIPHER::AlignSeqs(DNAStringSet(seqs), anchor=NA)
# First construct a neighbor-joining tree, and then fit a GTR+G+I
#  (Generalized time-reversible with Gamma rate variation) maximum
#  likelihood tree using the neighbor-joining tree as a starting point.
library(phangorn)
phang.align <- phangorn::phyDat(as(alignment, "matrix"), type="DNA")
dm <- phangorn::dist.ml(phang.align)
treeNJ <- NJ(dm) # Note: tip order != sequence order
fitNJ <- pml(treeNJ, data=phang.align)
fitGTR <- update(fitNJ, k=4, inv=0.2)
fitGTR <- optim.pml(fitGTR, model="GTR", optInv=TRUE, optGamma=TRUE,
                   rearrangement = "stochastic", control = pml.control(trace = 0))
# if you want to root but don’t have an obvious outgroup
fitGTR_rooted <- phangorn::midpoint(fitGTR)
is.rooted(fitGTR) # Is the tree Rooted?
is.binary.tree(fitGTR) # All multichotomies resolved?
# TODO Add the three
}



# Biomarkers
# Manually checked that the sample order corresponds;
# let us rename the samples so they have same names in the different tables
bm <- t(meta[inds, -match(vars, colnames(meta))])
bm <- as.matrix(bm)
colnames(bm) <- meta_cecum$Sample

# NMR
nmr$Rat <- NULL # Can be removed after matching
nmr <- t(nmr) # features x samples
nmr <- as.matrix(nmr)
colnames(nmr) <- meta_cecum$Sample

# Convert to MAE object
# build SummarizedExperiment objects
sem <- SummarizedExperiment(assays = list(counts=otu_cecum),
			    rowData = tax)
sen <- SummarizedExperiment(assays = list(nmr=nmr))
seb <- SummarizedExperiment(assays = list(signals=bm))

## Create a MultiAssayExperiment instance
ExpList <- ExperimentList(list(microbiota=sem,
                               metabolites=sen,
			       biomarkers=seb))
mae <- MultiAssayExperiment(experiments = ExpList,
                            colData = meta_cecum)
     
# Fetch the data from MAE object in order to ensure compabitility
# with ExperimentHub access
tax     <- rowData(mae[["microbiota"]])
counts  <- assay(mae[["microbiota"]], "counts")
nmr     <- assay(mae[["metabolites"]], "nmr")
bm      <- assay(mae[["biomarkers"]], "signals")
coldata <- colData(mae)

# Save the data components
path <- "../extras/microbiomeDataSets/3.14/hintikka-xo/"
saveRDS(tax,       file = paste0(path, "microbiota_rowdata.rds"))
saveRDS(counts,    file = paste0(path, "microbiota_counts.rds"))
saveRDS(nmr,       file = paste0(path, "metabolites_nmr.rds"))
saveRDS(bm,        file = paste0(path, "biomarkers_signals.rds"))
saveRDS(coldata,   file = paste0(path, "coldata.rds"))

#' Obtain the O'Keefe diet swap microbiome data
#'
#' Obtain the microbiome data from O'Keefe et al. (2015).
#'
#' @details
#' The OKeefeDS dataset contains microbiome data from a study with African and
#' African American groups undergoing a two-week diet swap.
#'
#' This data set is based on the Human Intestinal Tract (HIT)Chip
#' phylogenetic 16S microarray (Rajilic-Stojanovic _et al._ 2009.
#' This profiling technology differs from the more widely used 16S rRNA
#' amplicon sequencing.
#'
#' Column metadata includes the subject identifier, sex, nationality, group
#' information, sample identifier, time point information, time point
#' information within group and BMI group.
#'
#' Row metadata contains taxonomic information on the Phylum, Family and Genus
#' level.
#'
#' All data are downloaded from ExperimentHub and cached for local re-use.
#'
#' @return a \linkS4class{TreeSummarizedExperiment}
#'
#' @author Felix G.M. Ernst and Leo Lahti
#'
#' @references
#' O'Keefe S et al. (2015): Fat, fibre and cancer risk in African Americans and
#' rural Africans. \emph{Nature Communications} 6:6342 (2015)
#' \url{https://dx.doi.org/10.1038/ncomms7342}
#'
#' Rajilic-Stojanovic M, Heilig HG, Molenaar D, Kajander K, Surakka A, Smidt H,
#' de Vos WM (2009). Development and application of the human intestinal tract 
#' chip, a phylogenetic microarray: analysis of universally conserved phylotypes
#' in the abundant microbiota of young and elderly adults.
#' \emph{Environ Microbiol.} 11(7):1736-51
#' \url{https://doi.org/10.1111/j.1462-2920.2009.01900.x}
#'
#' @name OKeefeDSData
#' @export
#'
#' @examples
#' tse <- OKeefeDSData()
OKeefeDSData <- function() {
    dataset <- "3.13/okeefe-ds"
    tse <- .create_tse(dataset,
                    assays = c("counts"),
                    has.rowdata = TRUE,
                    has.coldata = TRUE)
    tse
}

#' @rdname OKeefeDSData
#' @export
dietswap <- OKeefeDSData

#' Obtain the Song quality assurance dataset
#'
#' Obtain the microbiome data from Song et al. (2016).
#'
#' @details
#' The SongQA dataset contains microbiome data from a study comparing different
#' sample preparation methods focusing on temperature and DNA extraction methods
#' mainly.
#'
#' The dataset was generated by sequencing the variable region 4 of 16S rRNA
#' genes via Illumina HiSeq or MiSeq. 
#'
#' Column metadata was reconstructed from sample names and includes information
#' on the source, timepoint, extraction method, temperature conditions and 
#' other optional data.
#'
#' Row metadata contains taxonomic information on the Phylum, Family and Genus
#' level.
#'
#' All data are downloaded from ExperimentHub and cached for local re-use.
#'
#' @return a \linkS4class{TreeSummarizedExperiment}
#'
#' @author Felix G.M. Ernst
#'
#' @references
#' Preservation Methods Differ in Fecal Microbiome Stability, Affecting 
#' Suitability for Field Studies. Se Jin Song, Amnon Amir, Jessica L. Metcalf, 
#' Katherine R. Amato, Zhenjiang Zech Xu, Greg Humphrey, Rob Knight.
#' mSystems May 2016, 1 (3) e00021-16; DOI: 10.1128/mSystems.00021-16
#' 
#' @source 
#' https://qiita.ucsd.edu/study/description/10394
#'
#' @name SongQAData
#' @export
#'
#' @examples
#' tse <- SongQAData()
SongQAData <- function() {
    dataset <- "3.13/song-qa"
    tse <- .create_tse(dataset,
                    assays = c("counts"),
                    has.rowdata = TRUE,
                    has.coldata = TRUE,
                    has.rowtree = TRUE)
    tse
}

#' @rdname SongQAData
#' @export
qa10934 <- SongQAData

library(dplyr)
library(R.utils)
library(stringr)

BiocVersion <- "3.14"
path <- paste0("microbiomeDataSets/",BiocVersion,"/")

df_Base <- data.frame(
  BiocVersion = BiocVersion,
  SourceVersion = NA,
  Coordinate_1_based = TRUE,
  Species = "Papio cynocephalus",
  TaxonomyId = "9556",
  SourceVersion=Sys.time(),
  Genome = NA,
  SourceUrl = "https://science.sciencemag.org/content/373/6551/181",
  DataProvider = "University of Minnesota",
  Maintainer = "Leo Lahti <leo.lahti@iki.fi>"  
)

df <- rbind(
  cbind(df_Base,
       data.frame(
                  Title = "Grieneisen Baboon counts data set",
                  Description = paste0("Count matrix for the Grieneisen Baboon dataset"),
                  SourceType = "RDS",
                  RDataClass = "matrix",
                  DispatchClass = "RDS",
                  RDataPath = paste0(path,"grieneisen-ts/counts.rds"),
                  Tags = NA)),
  cbind(df_Base,
        data.frame(
                  Title = "Grieneisen Baboon row data set",
                  Description = paste0("Taxonomy table for the Grieneisen Baboon dataset"),
                  SourceType = "RDS",
                  RDataClass = "DFrame",
                  DispatchClass = "RDS",
                  RDataPath = paste0(path,"grieneisen-ts/rowdata.rds"),
                  Tags = NA)),
  cbind(df_Base,
        data.frame(
                  Title = "Grieneisen Baboon phylogenetic tree data set",
                  Description = paste0("Phylogenetic tree for the Grieneisen Baboon dataset"),
                  SourceType = "TXT",
                  RDataClass = "character",
                  DispatchClass = "FilePath",
                  RDataPath = paste0(path,"grieneisen-ts/rowtree.tre.gz"),
                  Tags = NA)),
  cbind(df_Base,
        data.frame(
                  Title = "Grieneisen Baboon sample data set",
                  Description = paste0("Sample information for the Grieneisen Baboon dataset"),
                  SourceType = "CSV",
                  RDataClass = "Dframe",
                  DispatchClass = "RDS",
                  RDataPath = paste0(path,"grieneisen-ts/coldata.rds"),
                  Tags = NA)),
  cbind(df_Base,
        data.frame(
                  Title = "Grieneisen Baboon sequence data set",
                  Description = paste0("Sequence data for the Grieneisen Baboon dataset"),
                  SourceType = "TXT",
                  RDataClass = "character",
                  DispatchClass = "FilePath",
                  RDataPath = paste0(path,"grieneisen-ts/refseq.fasta.gz"),
                  Tags = NA))
)

df$Tags <- paste(df$Tags[!is.na(df$Tags)],"Microbiome",collapse = ":",sep="") 


write.csv(df, file = paste0("../extdata/",BiocVersion,"/metadata-grieneisen-ts.csv"),
          row.names = FALSE)

# Base data for all data sets --------------------------------------------------
library(S4Vectors)

BiocVersion <- "3.13"
path <- paste0("microbiomeDataSets/",BiocVersion,"/")

df_Base <- DataFrame(
    BiocVersion = BiocVersion,
    SourceVersion = NA,
    Coordinate_1_based = TRUE,
    Species = "Homo sapiens",
    TaxonomyId = "9606",
    SourceVersion = Sys.time(),
    Genome = NA,
    SourceUrl = "http://msystems.asm.org/content/1/3/e00021-16,https://qiita.ucsd.edu/study/description/10394",
    DataProvider = "Qiita",
    Maintainer = "Felix GM Ernst <felix.gm.ernst@outlook.com>"
)

#

df <- rbind(
    cbind(df_Base,
          DataFrame(Title = "Song et al. 2012 dataset OTU count matrix",
                    Description = paste0("Count matrix for the Song et al. 2012 dataset"),
                    SourceType = "CSV",
                    RDataClass = "matrix",
                    DispatchClass = "Rds",
                    RDataPath = paste0(path,"song-qa/counts.rds"),
                    Tags = NA)),
    cbind(df_Base,
          DataFrame(Title = "Song et al. 2012 dataset row data",
                    Description = paste0("Row data for the Song et al. 2012 dataset"),
                    SourceType = "CSV",
                    RDataClass = "DFrame",
                    DispatchClass = "Rds",
                    RDataPath = paste0(path,"song-qa/rowdata.rds"),
                    Tags = NA)),
    cbind(df_Base,
          DataFrame(Title = "Song et al. 2012 dataset sample data",
                    Description = paste0("Sample data for the Song et al. 2012 dataset"),
                    SourceType = "CSV",
                    RDataClass = "DFrame",
                    DispatchClass = "Rds",
                    RDataPath = paste0(path,"song-qa/coldata.rds"),
                    Tags = NA)),
    cbind(df_Base,
          DataFrame(Title = "Song et al. 2012 dataset feature tree",
                    Description = paste0("Feature tree for the Song et al. 2012 dataset"),
                    SourceType = "TXT",
                    RDataClass = NA,
                    DispatchClass = "FilePath",
                    RDataPath = paste0(path,"song-qa/rowtree.tre.gz"),
                    Tags = NA))
)

df$Tags <- paste(df$Tags[!is.na(df$Tags)],"Microbiome",collapse = ":",sep="")

write.csv(df, file = paste0("../extdata/",BiocVersion,"/metadata-song-qa.csv"),
          row.names = FALSE)

---
title: "microbiomeDataSets"
date: "`r Sys.Date()`"
package: microbiomeDataSets
output: 
    BiocStyle::html_document:
        fig_height: 7
        fig_width: 10
        toc: yes
        toc_depth: 2
        number_sections: true
vignette: >
    %\VignetteIndexEntry{microbiomeDataSets}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
bibliography: references.bib  
---

```{r, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>"
)
```

```{r setup, message=FALSE}
library(microbiomeDataSets)
```

# Microbiome example data sets

The data sets are primarily named by the first author of the
associated publication, together with a descriptive suffix. Aliases
are provided for some of the data sets.

A table of the available data sets is available through the `availableDataSets`
function.

```{r}
availableDataSets()
```

All data are downloaded from ExperimentHub and cached for local
re-use. Check the [man pages of each
function](https://microbiome.github.io/microbiomeDataSets/reference/index.html)
for a detailed documentation of the data contents and original source.

The microbiome data is usually loaded as a
`r Biocpkg("TreeSummarizedExperiment")`. If other associated data tables
(metabolomic, biomarker..) are provided, the integrated data
collection is provided as `r Biocpkg("MultiAssayExperiment")`.

For more information on how to use these objects, please refer to the
vignettes of those packages.


```{r}
#rebook::prettySessionInfo()
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{availableDataSets}
\alias{availableDataSets}
\title{Load available microbiome data sets}
\usage{
availableDataSets()
}
\value{
A \code{data.frame} containing the following columns:
\itemize{
\item{Dataset:} {the name of the function to load a dataset}
}
}
\description{
To list the available datasets in \code{microbiomeDataSets},
run \code{availableDataSets}.
}
\details{
For information visit the individual man pages.
}
\examples{
availableDataSets()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SongQAData.R
\name{SongQAData}
\alias{SongQAData}
\alias{qa10934}
\title{Obtain the Song quality assurance dataset}
\source{
https://qiita.ucsd.edu/study/description/10394
}
\usage{
SongQAData()

qa10934()
}
\value{
a \linkS4class{TreeSummarizedExperiment}
}
\description{
Obtain the microbiome data from Song et al. (2016).
}
\details{
The SongQA dataset contains microbiome data from a study comparing different
sample preparation methods focusing on temperature and DNA extraction methods
mainly.

The dataset was generated by sequencing the variable region 4 of 16S rRNA
genes via Illumina HiSeq or MiSeq.

Column metadata was reconstructed from sample names and includes information
on the source, timepoint, extraction method, temperature conditions and
other optional data.

Row metadata contains taxonomic information on the Phylum, Family and Genus
level.

All data are downloaded from ExperimentHub and cached for local re-use.
}
\examples{
tse <- SongQAData()
}
\references{
Preservation Methods Differ in Fecal Microbiome Stability, Affecting
Suitability for Field Studies. Se Jin Song, Amnon Amir, Jessica L. Metcalf,
Katherine R. Amato, Zhenjiang Zech Xu, Greg Humphrey, Rob Knight.
mSystems May 2016, 1 (3) e00021-16; DOI: 10.1128/mSystems.00021-16
}
\author{
Felix G.M. Ernst
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GrieneisenTSData.R
\name{GrieneisenTSData}
\alias{GrieneisenTSData}
\alias{baboongut}
\title{Retrieve GrieneisenTS data}
\usage{
GrieneisenTSData()

baboongut()
}
\value{
A \linkS4class{TreeSummarizedExperiment} object.
}
\description{
Obtain longitudinal gut microbiome data in wild baboons from
Grieneisen et al. (2021).
}
\details{
The GrieneisenTS dataset contains 16,234 16S rRNA gene
sequencing-based microbiome profiles from 585 baboon samples
collected over 14 years to determine the heritability of the
gut microbiome on various environmental factors such as
diet, age, season. Each baboon had an average of 28 samples
collected over 4.5 years. The data set can be used to
investigate significance of longitudinal sampling at large
sample sizes.

This data set contains the 613 most prevalent taxa with a
phylogenetic tree.

Column metadata includes the following fields:
\itemize{
\item{sample: } {Sample ID (character)}
\item{baboon_id: } {Baboon ID (factor)}
\item{collection_date: } {Sample collection date (date ; YYYY-MM-DD)}
\item{sex: } {Sex (factor; F/M)}
\item{age: } {Age (numeric)}
\item{social_group: } {Social group ID (factor)}
\item{group_size: } {Social group size (integer)}
\item{rain_month_mm: } {Rain per month(mm) (numeric)}
\item{season: } {Season (factor; dry/wet)}
\item{hydro_year: } {Hydro year (integer)}
\item{month: } {Month (integer)}
\item{readcount: } {Read count (numeric)}
\item{plate: } {Plate (factor)}
\item{post_pcr_dna_ng: } {Post PCR DNA(ng) (numeric)}
\item{diet_PC1: } {Diet Principal coordinate 1 (numeric)}
\item{diet_PC2: } {Diet Principal coordinate 2 (numeric)}
\item{diet_PC3: } {Diet Principal coordinate 3 (numeric)}
\item{diet_PC4: } {Diet Principal coordinate 4 (numeric)}
\item{diet_PC5: } {Diet Principal coordinate 5 (numeric)}
\item{diet_PC6: } {Diet Principal coordinate 6 (numeric)}
\item{diet_PC7: } {Diet Principal coordinate 7 (numeric)}
\item{diet_PC8: } {Diet Principal coordinate 8 (numeric)}
\item{diet_PC9: } {Diet Principal coordinate 9 (numeric)}
\item{diet_PC10: } {Diet Principal coordinate 10 (numeric)}
\item{diet_PC11: } {Diet Principal coordinate 11 (numeric)}
\item{diet_PC12: } {Diet Principal coordinate 12 (numeric)}
\item{diet_PC13: } {Diet Principal coordinate 13 (numeric)}
\item{diet_shannon_h: } {Dietary Shannon's H index (numeric)}
\item{asv_richness: } {Amplicon sequence variant (ASV) richness (integer)}
\item{asv_shannon_h: } {ASV Shannon's H index (numeric)}
\item{pc1_bc: } {Principal coordinate 1 Bray-Curtis dissimilarity (numeric)}
\item{pc2_bc: } {Principal coordinate 2 Bray-Curtis dissimilarity (numeric)}
\item{pc3_bc: } {Principal coordinate 3 Bray-Curtis dissimilarity (numeric)}
\item{pc4_bc: } {Principal coordinate 4 Bray-Curtis dissimilarity (numeric)}
\item{pc5_bc: } {Principal coordinate 5 Bray-Curtis dissimilarity (numeric)}
}

Row metadata of the microbiome data contains taxonomic information on the
Domain, Phylum, Class, Order, Family, Genus, and ASV levels.

The row tree consists of a phylogenetic tree build using sequence
information of 613 taxa.

As reference sequences the ASV are provided.
}
\examples{
tse <- GrieneisenTSData()

}
\references{
Grieneisen et al. (2021):
Gut microbiome heritability is nearly universal but
environmentally contingent
\emph{Science}
373:6551 \url{https://science.sciencemag.org/content/373/6551/181.full}
}
\author{
Yagmur Simsek and Leo Lahti
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SilvermanAGutData.R
\name{SilvermanAGutData}
\alias{SilvermanAGutData}
\alias{artificialgut}
\title{Obtain the Silverman Artificial Gut data}
\usage{
SilvermanAGutData()

artificialgut()
}
\value{
a \linkS4class{TreeSummarizedExperiment}
}
\description{
Obtain the microbiome data from Silverman et al. (2018).
}
\details{
The SilvermanAGutData dataset contains 16S rRNA gene based high-throughput
profiling of 4 in vitro artificial gut models. The sampling was done hourly
and daily to capture sub-daily dynamics of microbial community originating
from human feces. The data consists of 413 taxa from 639 samples. The data
set can be used to investigate longitudinal dynamics of microbial community
in a controlled environment.

Column metadata includes the days of sampling, vessel identifier, sampling
frequency pre-post challenge with Bacteroides ovatus.

The wow metadata of the microbiome data contains taxonomic information on the
Kingdom, Phylum, Class, Order, Family and Genus and Species level.

The row tree consists of a phylogenetic tree build using sequence information
of 413 taxa.

As reference sequences the ASV are provided.

All data are downloaded from ExperimentHub and cached for local re-use.
}
\examples{
tse <- SilvermanAGutData()
}
\references{
Silveman J.D et al. (2018): Dynamic linear models guide design and
analysis of microbiota studies within artificial human guts.
\emph{Microbiome} 6:202 \url{https://doi.org/10.1186/s40168-018-0584-3}
}
\author{
Sudarshan A. Shetty and Felix G.M. Ernst
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SprockettTHData.R
\name{SprockettTHData}
\alias{SprockettTHData}
\title{Obtain the Sprockett Tsimane Horticulturalists data}
\usage{
SprockettTHData()
}
\value{
a \linkS4class{TreeSummarizedExperiment}
}
\description{
Obtain the microbiome data from Sprockett et al. (2020).
}
\details{
The SprockettTHData dataset contains 16S rRNA gene based high-throughput
profiling of 1966 Feces, 120 Saliva samples from 319 participants from
Bolivia, Finland and Bangladesh. These include samples from adults,
children, and infants. Several participants have longitudinal samples.
The data consists of 2319 taxa from 2086 samples. The data
set can be used to investigate assembly, structure, and dynamics as well
as associations between several host related parameters with microbiota.

Column metadata includes the sex, age, feeding status, delivery mode,
country, and other information.

The row metadata of the microbiome data contains taxonomic information
on the Kingdom, Phylum, Class, Order, Family and Genus, Species and
lowest taxonomic rank.

The row tree consists of a phylogenetic tree build using sequence
information of 2319 taxa.

As reference sequences the ASV are provided.

All data are downloaded from ExperimentHub and cached for local re-use.
}
\examples{
tse <- SprockettTHData()
}
\references{
Sprockett, D.D., Martin, M., Costello, E.K. et al. (2020)
Microbiota assembly, structure, and dynamics among Tsimane
horticulturalists of the Bolivian Amazon.
\emph{Nat Commun} 11, 3772 \url{https://doi.org/10.1038/s41467-020-17541-6}

Subramanian, S., Huq, S., Yatsunenko, T., et al. (2014) Persistent gut
microbiota immaturity in malnourished Bangladeshi children.
\emph{Nature} 510, 417-421 \url{https://doi.org/10.1038/nature13421}

Vatanen, T., Kostic A.D., d'Hennezel E., et al. (2016) Variation in
microbiome LPS immunogenicity contributes to autoimmunity in humans.
\emph{Cell} 165, 842-853 \url{https://doi.org/10.1016/j.cell.2016.04.007}
}
\author{
Sudarshan A. Shetty and Felix G.M. Ernst
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/microbiomeDataSets.R
\name{microbiomeDataSets-package}
\alias{microbiomeDataSets-package}
\title{Microbiome data sets}
\description{
\code{microbiomeDataSets} is a collation of data from microbiome and
associated studies, which are publicaly available.
}
\details{
The data is made available through the ExperimentHub resources of the
Bioconductor project. It is loaded as \code{TreeSummarizedExperiment}
object or a \code{MultiAssayExperiment} objects.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LahtiMLData.R
\name{LahtiMLData}
\alias{LahtiMLData}
\alias{LahtiMData}
\alias{peerj32}
\title{Obtain the Lahti Microbiome and Lipid data}
\usage{
LahtiMLData()

LahtiMData()

peerj32()
}
\value{
for  \code{LahtiMLData} a \linkS4class{MultiAssayExperiment} object
with \linkS4class{TreeSummarizedExperiment} and a
\linkS4class{SummarizedExperiment},
for  \code{LahtiMData} a \linkS4class{TreeSummarizedExperiment}
}
\description{
Obtain the microbiome and lipid data from Lahti et al. (2013).
}
\details{
The LahtiML dataset contains high-throughput profiling data from 389 human
blood serum lipids and 130 intestinal genus-level bacteria from 44 samples
(22 subjects from 2 time points; before and after probiotic/placebo
intervention). The data set can be used to investigate associations between
intestinal bacteria and host lipid metabolism

This data set is based on the Human Intestinal Tract (HIT)Chip
phylogenetic 16S microarray (Rajilic-Stojanovic \emph{et al.} 2009.
This profiling technology differs from the more widely used 16S rRNA
amplicon sequencing.

Column metadata includes the time points, sex, subject identifier, sample
identifier and treatment group.

Row metadata of the microbiome data contains taxonomic information on the
Phylum, Family and Genus level.

All data are downloaded from ExperimentHub and cached for local re-use.
}
\examples{
mae <- LahtiMLData()
tse <- LahtiMData()
}
\references{
Lahti L et al. (2013): Associations between the human intestinal microbiota,
Lactobacillus rhamnosus GG and serum lipids indicated by integrated analysis
of high-throughput profiling data.
\emph{PeerJ} 1:e32 \url{https://doi.org/10.7717/peerj.32}

Rajilic-Stojanovic M, Heilig HG, Molenaar D, Kajander K, Surakka A, Smidt H,
de Vos WM (2009). Development and application of the human intestinal tract
chip, a phylogenetic microarray: analysis of universally conserved phylotypes
in the abundant microbiota of young and elderly adults.
\emph{Environ Microbiol.} 11(7):1736-51
\url{https://doi.org/10.1111/j.1462-2920.2009.01900.x}
}
\author{
Felix G.M. Ernst and Leo Lahti
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/OKeefeDSData.R
\name{OKeefeDSData}
\alias{OKeefeDSData}
\alias{dietswap}
\title{Obtain the O'Keefe diet swap microbiome data}
\usage{
OKeefeDSData()

dietswap()
}
\value{
a \linkS4class{TreeSummarizedExperiment}
}
\description{
Obtain the microbiome data from O'Keefe et al. (2015).
}
\details{
The OKeefeDS dataset contains microbiome data from a study with African and
African American groups undergoing a two-week diet swap.

This data set is based on the Human Intestinal Tract (HIT)Chip
phylogenetic 16S microarray (Rajilic-Stojanovic \emph{et al.} 2009.
This profiling technology differs from the more widely used 16S rRNA
amplicon sequencing.

Column metadata includes the subject identifier, sex, nationality, group
information, sample identifier, time point information, time point
information within group and BMI group.

Row metadata contains taxonomic information on the Phylum, Family and Genus
level.

All data are downloaded from ExperimentHub and cached for local re-use.
}
\examples{
tse <- OKeefeDSData()
}
\references{
O'Keefe S et al. (2015): Fat, fibre and cancer risk in African Americans and
rural Africans. \emph{Nature Communications} 6:6342 (2015)
\url{https://dx.doi.org/10.1038/ncomms7342}

Rajilic-Stojanovic M, Heilig HG, Molenaar D, Kajander K, Surakka A, Smidt H,
de Vos WM (2009). Development and application of the human intestinal tract
chip, a phylogenetic microarray: analysis of universally conserved phylotypes
in the abundant microbiota of young and elderly adults.
\emph{Environ Microbiol.} 11(7):1736-51
\url{https://doi.org/10.1111/j.1462-2920.2009.01900.x}
}
\author{
Felix G.M. Ernst and Leo Lahti
}
